/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package conexionCredibanco.controller;

import conexionCredibanco.controller.exceptions.NonexistentEntityException;
import conexionCredibanco.controller.exceptions.PreexistingEntityException;
import conexionCredibanco.entity.RefCodigosRespuesta;
import java.io.Serializable;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

/**
 *
 * @author viatori
 */
public class RefCodigosRespuestaJpaController implements Serializable {

    public RefCodigosRespuestaJpaController(EntityManagerFactory emf) {
        this.emf = emf;
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(RefCodigosRespuesta refCodigosRespuesta) throws PreexistingEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            em.persist(refCodigosRespuesta);
            em.getTransaction().commit();
        } catch (Exception ex) {
            if (findRefCodigosRespuesta(refCodigosRespuesta.getCodigo()) != null) {
                throw new PreexistingEntityException("RefCodigosRespuesta " + refCodigosRespuesta + " already exists.", ex);
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(RefCodigosRespuesta refCodigosRespuesta) throws NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            refCodigosRespuesta = em.merge(refCodigosRespuesta);
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                String id = refCodigosRespuesta.getCodigo();
                if (findRefCodigosRespuesta(id) == null) {
                    throw new NonexistentEntityException("The refCodigosRespuesta with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(String id) throws NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            RefCodigosRespuesta refCodigosRespuesta;
            try {
                refCodigosRespuesta = em.getReference(RefCodigosRespuesta.class, id);
                refCodigosRespuesta.getCodigo();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The refCodigosRespuesta with id " + id + " no longer exists.", enfe);
            }
            em.remove(refCodigosRespuesta);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<RefCodigosRespuesta> findRefCodigosRespuestaEntities() {
        return findRefCodigosRespuestaEntities(true, -1, -1);
    }

    public List<RefCodigosRespuesta> findRefCodigosRespuestaEntities(int maxResults, int firstResult) {
        return findRefCodigosRespuestaEntities(false, maxResults, firstResult);
    }

    private List<RefCodigosRespuesta> findRefCodigosRespuestaEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
            cq.select(cq.from(RefCodigosRespuesta.class));
            Query q = em.createQuery(cq);
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

    public RefCodigosRespuesta findRefCodigosRespuesta(String id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(RefCodigosRespuesta.class, id);
        } finally {
            em.close();
        }
    }

    public int getRefCodigosRespuestaCount() {
        EntityManager em = getEntityManager();
        try {
            CriteriaQuery cq = em.getCriteriaBuilder().createQuery();
            Root<RefCodigosRespuesta> rt = cq.from(RefCodigosRespuesta.class);
            cq.select(em.getCriteriaBuilder().count(rt));
            Query q = em.createQuery(cq);
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }
    
}
